import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;

/**
 * Write a description of class Arrow here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Arrow extends Enemy
{
    public int dir;
    
    public Arrow(int dir){
        if (dir < 0) {dir = 0;}
        else if (dir > 3) {dir = 3;};
        spr = new GreenfootImage[4];
        spr[0] = new GreenfootImage("spr_sheet/arrow_down.png");
        spr[1] = new GreenfootImage("spr_sheet/arrow_left.png");
        spr[2] = new GreenfootImage("spr_sheet/arrow_right.png");
        spr[3] = new GreenfootImage("spr_sheet/arrow_up.png");
        this.dir = dir;
        move_delay = 3;
        setImage(spr[dir]);
    }
    
    public void act(){
        move();
    }
    
    public void move(){
        setLocation(x,y);
        killAnyoneOnTheWay();
        move_delay--;
        if (canMove && !dead && move_delay < 0){
            if (checkMovable(dir)){
                moveDecision(dir);
            } else {
                die();
                return;
            }
            move_delay = 3;
        }
    }
   
    private void killAnyoneOnTheWay(){
        Mortal victim = (Mortal)getOneObjectAtOffset(0, 0, Mortal.class);
        if(victim != null){
            victim.die();
            if (victim instanceof Enemy){
                die();
                return;
                
            }
        }
        
        if (getOneObjectAtOffset(0, 0, Explosion.class) != null){
             die();
             return;
         }
         
         if (getX() <= 1 || getX() >= getWorld().getWidth() -1
         || getY() <= 1 || getY() >= getWorld().getHeight() -1){
             die();
             return;
            }
    }
    
    /**
     * Make sure no objects is in the way in the specific direction
     */
    public boolean checkMovable(int dir){
        boolean movable = false;
        List list = getObjectsNextTo(dir);
        if (list.size() == 0){
            return true;
        }
        for(int i = 0; i < list.size(); i++){
            if(list.get(i).getClass() == Space.class){
                movable = true;
            } 
            else if (list.get(i).getClass() != Space.class && list.get(i).getClass() != Spot.class
            && list.get(i).getClass() != Boy.class && list.get(i).getClass() != Girl.class && 
            list.get(i).getClass() != Goblin.class && list.get(i).getClass() != Slime.class && 
            list.get(i).getClass() != Explosion.class && list.get(i).getClass() != LevelComplete.class){
                return false;
            }
            
        }
        
        return movable;
    }
    
}
