import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;

/**
 * Write a description of class Enemy here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public abstract class Enemy extends Actor implements Mortal
{
    protected GreenfootImage[] spr;
    
    protected boolean dead = false;
    protected boolean frozen = false;
    
    protected boolean isMoving;
    protected boolean canMove;
    protected int moveTimer = 4000000;
    
    protected int x,y;
    
    protected int move_delay = 100;
    
    protected int facing_dir = 0;
    protected int spr_i = 0;
    
    public Enemy(){
        isMoving = false;
        canMove = true;
    }
    
    public void act() 
    {
        moveAI();
        killPlayerWhenTouched();
    }    
    
    public void addedToWorld(World world){
        x = getX();
        y = getY();
    }
    
    protected void killPlayerWhenTouched(){
       
       Player player = (Player)getOneObjectAtOffset(0, 0, Player.class);
            if(player != null){
                player.die();
            }
        
        
    }
    
    protected void moveAI(){
        setLocation(x,y);
        move_delay--;
        if (canMove && !dead && move_delay < 0){
            int decision_dir = Greenfoot.getRandomNumber(3);
            if (checkMovable(decision_dir)){
                moveDecision(decision_dir);
            }
            move_delay = 100;
        }
        
    }
    
    /**
     * Movement decision, choose random 4 directions, if there is something on the way in the 
     * chosen direction, the enemy will just stop for a while.
     */
    public void moveDecision(int dir){
        if(dir == 0){
            isMoving = true;
                canMove = false;
                while(moveTimer > 0){
                    if(moveTimer % 1000000 == 0){
                        y++;
                    }
                    moveTimer--;
                }
                moveTimer = 4000000;
                isMoving = false;
                canMove = true;
                facing_dir = 0;
        } else if (dir == 1){
            isMoving = true;
                canMove = false;
                while(moveTimer > 0){
                    if(moveTimer % 1000000 == 0){
                       x--;
                    }
                    moveTimer--;
                }
                moveTimer = 4000000;
                isMoving = false;
                canMove = true;
                facing_dir = 1;
        } else if (dir == 2){
            isMoving = true;
                canMove = false;
                while(moveTimer > 0){
                    if(moveTimer % 1000000 == 0){
                        x++;
                    }
                    moveTimer--;
                }
                moveTimer = 4000000;
                isMoving = false;
                canMove = true;
                facing_dir = 2;
        } else if (dir == 3){
            isMoving = true;
                canMove = false;
                while(moveTimer > 0){
                    if(moveTimer % 1000000 == 0){
                        y--;
                    }
                    moveTimer--;
                }
                moveTimer = 4000000;
                isMoving = false;
                canMove = true;
                facing_dir = 3;
        }
    }
    
    /**
     * Make sure no objects is in the way in the specific direction
     */
    public boolean checkMovable(int dir){
        boolean movable = false;
        List list = getObjectsNextTo(dir);
        for(int i = 0; i < list.size(); i++){
            if(list.get(i).getClass() == Space.class){
                movable = true;
            } 
            else if (list.get(i).getClass() != Space.class && list.get(i).getClass() != Spot.class
            && list.get(i).getClass() != Boy.class && list.get(i).getClass() != Girl.class &&
            list.get(i).getClass() != Explosion.class && list.get(i).getClass() != LevelComplete.class){
                return false;
            }
            
        }
        
        return movable;
    }
    
    public List getObjectsNextTo(int dir){
        if(dir == 0){
            return this.getObjectsAtOffset(0, 4, Actor.class);
        } else if (dir == 1){
            return this.getObjectsAtOffset(-4, 0, Actor.class);
        } else if (dir == 2){
            return this.getObjectsAtOffset(4, 0, Actor.class);
        } else if (dir == 3){
            return this.getObjectsAtOffset(0, -4, Actor.class);
        } else {
            return null;
        }
    }
    
    public void die(){
        getWorld().addObject(new Explosion(),getX(),getY());
        Sound.enemyDie();
        getWorld().removeObject(this);
    }
    
    public void freeze(){
        frozen = true;
        canMove = false;
    }
    
    public void unfreeze(){
        frozen = false;
        canMove = true;
    }
}
