import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Goblin here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Goblin extends Enemy
{
    public int patrol_dir;
    //ver = 0, hor = 1
    
    public int facing = 0;
    public int facing_id = 1;
    public int walking_id = 0;
    
    protected int shoot_delay = 10;
    
    public Goblin(int patrol_dir){
        spr = new GreenfootImage[12];
        if(patrol_dir <= 0){
            this.patrol_dir = 0;
        } else {
            this.patrol_dir = 1;
        }
        
        spr[0] = new GreenfootImage("spr_sheet/goblin_d0.png");
        spr[1] = new GreenfootImage("spr_sheet/goblin_d1.png");
        spr[2] = new GreenfootImage("spr_sheet/goblin_d2.png");
        spr[3] = new GreenfootImage("spr_sheet/goblin_l0.png");
        spr[4] = new GreenfootImage("spr_sheet/goblin_l1.png");
        spr[5] = new GreenfootImage("spr_sheet/goblin_l2.png");
        spr[6] = new GreenfootImage("spr_sheet/goblin_r0.png");
        spr[7] = new GreenfootImage("spr_sheet/goblin_r1.png");
        spr[8] = new GreenfootImage("spr_sheet/goblin_r2.png");
        spr[9] = new GreenfootImage("spr_sheet/goblin_u0.png");
        spr[10] = new GreenfootImage("spr_sheet/goblin_u1.png");
        spr[11] = new GreenfootImage("spr_sheet/goblin_u2.png");
        
        move_delay = 20;
    }
    
     public void moveAI(){
        setLocation(x,y);
        move_delay--;
        shoot_delay--;
        if (canMove && !dead && move_delay < 0){
            int decision_dir = -1;
            if (patrol_dir == 0){
                if(facing == 0){
                    decision_dir = 0;
                    facing_id = 1;
                } else {
                    decision_dir = 3;
                    facing_id = 10;
                }
            } else {
                if(facing == 0){
                    decision_dir = 2;
                    facing_id = 7;
                } else {
                    decision_dir = 1;
                    facing_id = 4;
                }
            }
            
            if(seePlayerInDirection() > -1 && seePlayerInDirection() == facing_dir){
                    shootArrow();
                    return;
                }
            
            if (checkMovable(decision_dir)){
                
                moveDecision(decision_dir);
                if(walking_id == 0){
                    walking_id = 1;
                } else if(walking_id == 1){
                    walking_id = -1;
                } else {
                    walking_id = 1;
                }
            } else {
                if(facing == 0){
                    facing = 1;
                } else {
                    facing = 0;
                }
                walking_id = 0;
            }
            move_delay = 20;
            
            animate();
        } 
        
    }
    
    private void animate(){
        setImage(spr[facing_id+walking_id]);
    }
    
    public void shootArrow(){
        move_delay = 60;
        walking_id = 0;
        setImage(spr[facing_id+walking_id]);
        canMove = false;
        if (move_delay > 0 && checkMovable(facing_dir) && shoot_delay < 0){
            if(facing_dir == 0){
            //look down
            getWorld().addObject(new Arrow(facing_dir),getX(),getY()+4);
            
          } else if(facing_dir == 1){
            //look down
            getWorld().addObject(new Arrow(facing_dir),getX()-4,getY());
            
          } else if(facing_dir == 2){
            //look down
            getWorld().addObject(new Arrow(facing_dir),getX()+4,getY());
            
          } else if(facing_dir == 3){
            //look down
            getWorld().addObject(new Arrow(facing_dir),getX(),getY()-4);
            
          }
        }
        canMove = true;
        shoot_delay = 10;
        
    }
    
    public int seePlayerInDirection(){
        
        if (getOneObjectAtOffset(0, 32, Player.class) != null){
            return 0;
        } else if (getOneObjectAtOffset(-32, 0, Player.class) != null){
            return 1;
        } else if (getOneObjectAtOffset(32, 0, Player.class) != null){
            return 2;
        } else if (getOneObjectAtOffset(0, -32, Player.class) != null){
            return 3;
        }
        else if (getOneObjectAtOffset(0, 28, Player.class) != null){
            return 0;
        } else if (getOneObjectAtOffset(-28, 0, Player.class) != null){
            return 1;
        } else if (getOneObjectAtOffset(28, 0, Player.class) != null){
            return 2;
        } else if (getOneObjectAtOffset(0, -28, Player.class) != null){
            return 3;
        }
        else if (getOneObjectAtOffset(0, 24, Player.class) != null){
            return 0;
        } else if (getOneObjectAtOffset(-24, 0, Player.class) != null){
            return 1;
        } else if (getOneObjectAtOffset(24, 0, Player.class) != null){
            return 2;
        } else if (getOneObjectAtOffset(0, -24, Player.class) != null){
            return 3;
        }
        else if (getOneObjectAtOffset(0, 20, Player.class) != null){
            return 0;
        } else if (getOneObjectAtOffset(-20, 0, Player.class) != null){
            return 1;
        } else if (getOneObjectAtOffset(20, 0, Player.class) != null){
            return 2;
        } else if (getOneObjectAtOffset(0, -20, Player.class) != null){
            return 3;
        }
        else if (getOneObjectAtOffset(0, 16, Player.class) != null){
            return 0;
        } else if (getOneObjectAtOffset(-16, 0, Player.class) != null){
            return 1;
        } else if (getOneObjectAtOffset(16, 0, Player.class) != null){
            return 2;
        } else if (getOneObjectAtOffset(0, -16, Player.class) != null){
            return 3;
        }
        else if (getOneObjectAtOffset(0, 12, Player.class) != null){
            return 0;
        } else if (getOneObjectAtOffset(-12, 0, Player.class) != null){
            return 1;
        } else if (getOneObjectAtOffset(12, 0, Player.class) != null){
            return 2;
        } else if (getOneObjectAtOffset(0, -12, Player.class) != null){
            return 3;
        }
        else if (getOneObjectAtOffset(0, 8, Player.class) != null){
            return 0;
        } else if (getOneObjectAtOffset(-8, 0, Player.class) != null){
            return 1;
        } else if (getOneObjectAtOffset(8, 0, Player.class) != null){
            return 2;
        } else if (getOneObjectAtOffset(0, -8, Player.class) != null){
            return 3;
        } else if (getOneObjectAtOffset(0, 4, Player.class) != null){
            return 0;
        } else if (getOneObjectAtOffset(-4, 0, Player.class) != null){
            return 1;
        } else if (getOneObjectAtOffset(4, 0, Player.class) != null){
            return 2;
        } else if (getOneObjectAtOffset(0, -4, Player.class) != null){
            return 3;
        }else {
            return -1;
        }
    
    }
    
    public boolean seePlayer(){
        if(facing_dir == 0){
            Actor sight = null;
            int distance = 4;
            while(sight == null){
                sight = getOneObjectAtOffset(0, distance, Player.class);
                distance += 4;
                if(sight != null){
                    return true;
                }else {
                    sight = getOneObjectAtOffset(0, distance, Space.class);
                    if(sight != null){
                        sight = getOneObjectAtOffset(0, distance, Wall.class);
                        if(sight != null){
                           return false;
                        } else {
                            sight = getOneObjectAtOffset(0, distance, Block.class);
                            if(sight != null){
                                return false;
                            } else {
                                 sight = getOneObjectAtOffset(0, distance, Enemy.class);
                                 if(sight != null){
                                     return false;
                                    }
                            }
                        }
                    }
                }
            }
        } else if(facing_dir == 1){
            Actor sight = null;
            int distance = 4;
            while(sight == null){
                sight = getOneObjectAtOffset(distance, 0, Actor.class);
                distance -= 4;
                if(sight instanceof Player){
                    return true;
                } else if (!(sight instanceof Space)){
                    return false;
                }
            }
        } else if(facing_dir == 2){
            Actor sight = null;
            int distance = 4;
            while(sight == null){
                sight = getOneObjectAtOffset(distance, 0, Actor.class);
                distance += 4;
                if(sight instanceof Player){
                    return true;
                } else if (!(sight instanceof Space)){
                    return false;
                }
            }
        } else if(facing_dir == 3){
            Actor sight = null;
            int distance = 4;
            while(sight == null){
                sight = getOneObjectAtOffset(0, distance, Actor.class);
                distance -= 4;
                if(sight instanceof Player){
                    return true;
                } else if (!(sight instanceof Space)){
                    return false;
                }
            }
        }
        
        return false;
    }
    
    private void pushBlock(Block block, int dir){
        block.move(dir);
    }
}
