import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;

/**
 * An area where anybody can move into/pass to it.
 */
public class Space extends Actor
{
    /**Get what are standing on*/
    private List objects_StandingOn;
    
    /**Image instance variables of the space in colors*/
    private static final GreenfootImage BLUE = new GreenfootImage("space.png");
    private static final GreenfootImage GREEN = new GreenfootImage("space_1.png");
    private static final GreenfootImage YELLOW = new GreenfootImage("space_2.png");
    private static final GreenfootImage PINK = new GreenfootImage("space_3.png");
    private static final GreenfootImage RED = new GreenfootImage("space_4.png");
    
    /**
     * Initialize the space in blue color
     */
    public Space(){
        //default color
    }
    
    /**
     * Initialize the space in color_id values
     * color_id = 0 ; BLUE
     * color_id = 1 ; GREEN
     * color_id = 2 ; YELLOW
     * color_id = 3 ; PINK
     * color_id = 4 ; RED
     */
    public Space(int color_id){
        if(color_id == 1){
            setImage(GREEN);
        } else if (color_id == 2){
            setImage(YELLOW);
        } else if (color_id == 3){
            setImage(PINK);
        } else if (color_id == 4){
            setImage(RED);
        } else {
            setImage(BLUE);
        }
    }
    
    /**
     * Only reads what are standing on
     */
    public void act() 
    {
        objects_StandingOn = this.getObjectsAtOffset(0, 0, Actor.class);
    }    
    
    /**
     * Set the space's color in color_id values
     * color_id = 0 ; BLUE
     * color_id = 1 ; GREEN
     * color_id = 2 ; YELLOW
     * color_id = 3 ; PINK
     * color_id = 4 ; RED
     */
    public void setColor(int color_id){
        if(color_id == 1){
            setImage(GREEN);
        } else if (color_id == 2){
            setImage(YELLOW);
        } else if (color_id == 3){
            setImage(PINK);
        } else if (color_id == 4){
            setImage(RED);
        } else {
            setImage(BLUE);
        }
    }
    
}
