import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * An unmovable block, that is.
 */
public class Wall extends Actor
{
    /**2D coordinate*/
    public int x, y;
    
    /**Image instance variables of the wall in colors*/
    private static final GreenfootImage BLUE = new GreenfootImage("wall.png");
    private static final GreenfootImage GREEN = new GreenfootImage("wall_1.png");
    private static final GreenfootImage YELLOW = new GreenfootImage("wall_2.png");
    private static final GreenfootImage PINK = new GreenfootImage("wall_3.png");
    private static final GreenfootImage RED = new GreenfootImage("wall_4.png");
    
    /**
     * Initialize the wall in blue color
     */
    public Wall(){
       //default blue color 
    }       
    
    /**
     * Initialize the wall in color_id values
     * color_id = 0 ; BLUE
     * color_id = 1 ; GREEN
     * color_id = 2 ; YELLOW
     * color_id = 3 ; PINK
     * color_id = 4 ; RED
     */
    public Wall(int color_id){
        if(color_id == 1){
            setImage(GREEN);
        } else if (color_id == 2){
            setImage(YELLOW);
        } else if (color_id == 3){
            setImage(PINK);
        } else if (color_id == 4){
            setImage(RED);
        } else {
            setImage(BLUE);
        }
    }
    
    /**
     * Add wall to the world
     */
    public void addedToWorld(World world){
        x = getX();
        y = getY();
    }
    
    /**
     * Wall does nothing but stands in the game
     */
    public void act() 
    {
        // Add your action code here.
    }   
    
    /**
     * Set the wall's color in color_id values
     * color_id = 0 ; BLUE
     * color_id = 1 ; GREEN
     * color_id = 2 ; YELLOW
     * color_id = 3 ; PINK
     * color_id = 4 ; RED
     */
    public void setColor(int color_id){
        if(color_id == 1){
            setImage(GREEN);
        } else if (color_id == 2){
            setImage(YELLOW);
        } else if (color_id == 3){
            setImage(PINK);
        } else if (color_id == 4){
            setImage(RED);
        } else {
            setImage(BLUE);
        }
    }
}
